#define IDM_EDITOR      101
#define IDM_EXECUTER    102
#define IDM_OPTIONS     103
#define IDM_EXIT        104
#define IDM_VIEWER      105

#define IDC_X           500
#define IDC_Y           501
#define IDC_WIDTH       502
#define IDC_HEIGHT      503
#define IDC_STATUS_LINE 505
#define IDC_MENU        506
#define IDC_VER_BAR     507
#define IDC_HOR_BAR     508
#define IDC_FILE_BOX    509
#define IDC_BOX         510
#define IDC_TOOLBAR     511



/*****************************************************************************
    Prototypes
******************************************************************************/
BOOL    FAR PASCAL _export DemoForms(HWND,unsigned,WPARAM,LPARAM);
BOOL    FAR PASCAL _export DemoOptions(HWND,unsigned,WPARAM,LPARAM);
BOOL    InitApplication(HANDLE);
BOOL    InitInstance(HANDLE,int);
BOOL    GetNumVal(HWND,int,int *);
int     Bitmap2DIB(void);
int     CallEditor(BOOL);
int     ExtractField(char *,int *,int,char *);
BOOL    ExtractNextRecord(FILE *);
int     FAR PASCAL _export DemoFileField(HWND,unsigned,WPARAM,LPARAM);
BOOL    FAR PASCAL _export DemoRating(HWND,unsigned,WPARAM,LPARAM);
int     GetFormFiles(char *);
int     GetFormSelection(char *,int);
int     ModifyExt(char *,char *);
int     PASCAL WinMain(HINSTANCE,HINSTANCE,LPSTR,int);
int     PrepareFile(struct StrRep far *);
int     PrintRecords(int,struct StrField huge *,int);
int     ReadFields(void);
BOOL    ReadNextRecord(LPSTR);
BOOL    ReadPrevRecord(LPSTR);
BOOL    ReadRecord(LPSTR);
BOOL    ShowRecord(HWND,BOOL);
BOOL    WriteCurRecord(FILE *);
BOOL    WriteRecord(HWND,LPSTR,char);
int     FillForm(void);
int     FAR PASCAL _export UserFieldSelection(HWND,struct StrField huge *);
BOOL    FAR PASCAL _export VerifyData(HWND,struct StrField huge *);
BOOL    FAR PASCAL _export EnterData(HWND,struct StrField huge *,int,int,int,int);
int     FAR PASCAL _export DrawPicture(HWND,HDC,int,int,RECT far *);
long    FAR PASCAL _export DemoWndProc(HWND,UINT,WPARAM,LPARAM);
void    StringTrim(LPSTR);
void    RightTrim(LPSTR);
void    LeftTrim(LPSTR);
int     OurPrintf(LPSTR,...);
LPSTR   DoubleToStr(double,int,LPSTR);

/*****************************************************************************
    Constants used in the demo program.
******************************************************************************/
#define TRUE        1
#define FALSE       0

#define MAX_FORMS   100
#define MAX_FIELDS  25
#define MAX_RECS    15000

#define ITEM_WIDTH  40


/******************************************************************************
                      Global Variables for the Demo program
******************************************************************************/
HANDLE hInst,hPrevInst;             // Stores the current and previous instances 

HWND  hDemoWin;                     // demo program window 

struct StrForm FormParm;            // parameter structure used to call form routine 
                                                                        // see FORM.H file 
char FormName[MAX_FORMS+2][NAME_WIDTH+2]; // list of avialable form names 
char FormFile[MAX_FORMS+2][13];     // list of avialable form files 
int  TotalForms,NewReport;

char DataFile[]="CUSTOMER.DB";      // demo data file
char DataDefFile[]="CUSTOMER.DF";   // demo data definition file

struct StrFieldDef {                // data field definitions 
       char ShortName[15];          // data field name 
       char FullName[35];           // field name with file prefix 
       int  width;                  // display width of the field 
       int  type;                   // field type, see frs.h file  
       int  DecPlaces;              // decimal places for numeric/floating fields 
       int  RadioGroup;             // group number for the radio button fields
       long NumData;                // numeric data for the numeric fields
       double DblData;           // double data for the double numeric fields
       char TextData[301];          // text data for the text fields
       } FieldDef[MAX_FIELDS];

int    TotalFields;                 // total fields in the file

// fields to display a bitmap
HBITMAP  hLogoBM;                   // customer logo bitmap
HANDLE   hInfo,hImage;              // handle to the device independent bitmap
LPSTR    pImage;                    // pointer to the image data
LPBITMAPINFOHEADER pInfo;           // pointer to the image header data

// field to pass information to the dialog box
char   DlgText[300];                // used to pass text information to the dialog box
int    DlgInt1;                     // used to pass integer information to the dialog box
int    DlgInt2;                     // used to pass another integer to the dialog box

