unit Dmo_dlp1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus;

{$I frs.pas Form Plus constant and type declaration unit}

type
  Tmain = class(TForm)
    MainMenu1: TMainMenu;
    Edit1: TMenuItem;
    Run1: TMenuItem;
    procedure Edit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Run1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  main: Tmain;

{******************************************************************************
                      Global Constants for the Demo program
******************************************************************************}

const

  MAX_FORMS   =100;
  MAX_FILES   =1;
  MAX_FIELDS  =30;

  ITEM_WIDTH  =40;

{******************************************************************************
                      Global Structures for the Demo program
******************************************************************************}
type
    StrDataField = record         { data field definition}
       ShortName: string[15];     { data field nam}
       FullName: string[35];      { field name with file prefi}
       width: Integer;            { display width of the fiel}
       FieldType: Integer;        { field type, see form.h file}
       DecPlaces: Integer;        { decimal places for numeric/floating field}
       RadioGroup: Integer;       { group number for the radio button fields}
       NumData: LongInt;          { numeric data for the numeric field}
       DblData: double;           { double data for the double field}
       TextData: array [0..250] of char;   { text data for the text field}
    end;

    StrBitmap = record            { needed to use Windows API which use the BITMAP structure}
      bmType: Integer;
      bmWidth: Integer;
      bmHeight: Integer;
      bmWidthBytes: Integer;
      bmPlanes: Byte;
      bmBitsPixel: Byte;
      bmBits: Pointer;
    end;


{******************************************************************************
                      Global Variables for the Demo program
******************************************************************************}
var
   FormParm: StrForm;                          { form argument structure}

   FormName: array [0..MAX_FORMS+1] of string[NAME_WIDTH+2]; { list of avialable form name}
   FormFile: array [0..MAX_FORMS+1] of string[13]; { list of avialable form file}

   TotalForms, NewForm: Integer;
   SelectedForm:  Integer;  { index of the selected form to edit or run }

   CurField: Integer;        { currently selected data field}
   TotalFields: Integer;     { number of fields in the data file}

   DataField: array [0..MAX_FIELDS] of StrDataField;

   CurDataFile,              {current data file}
   CurDataDefFile,           {current data definition file}
   TempDataFile,             {temporary data file}
   BackupFile: string[128];  {backup file}

   KeyField: Integer;        {id of the keyfield in the data file}

   DlgResult,                {result value passed from the dialog box}
   DlgInt: Integer;          {parameter passed to the dialog box}

   { fields to display a bitm}

    logo: TBitmap;                  { bitmap object }
    hLogoBM: THandle;               { customer logo bitmap}

{*******************************************************************
    Program Function declarations
 *******************************************************************}
function GetFormSelection(var CurFile: string; FormEdit: WordBool): Integer;
procedure CallEditor;
Procedure GetFormFiles(template: string);
function ReadFields: WordBool;
function ExtractField(line: pChar;var idx: integer;LineLen: Integer;var CharReturn: string): WordBool;
function PStrTrim(InString: string): string;
function ReadRecord(CustId: array of char): WordBool;
function ReadNextRecord(CustId: array of char): WordBool;
function ReadPrevRecord(CustId: array of char): WordBool;
function ShowRecord(hWnd: THandle; initialize: WordBool): WordBool;
function ExtractNextRecord(var iStream: Text): WordBool;
function WriteRecord(hWnd: THandle; CustId: array of char; op: String): WordBool;
function GetRecordFromScreen(hWnd: THandle): WordBool;
function AddRecord(hWnd: THandle; CustId: array of char; var iStream: Text; var oStream: Text): WordBool;
function WriteCurRecord(var oStream: Text): WordBool;
function UpdateRecord(hWnd: THandle; CustId: array of char; var iStream: Text; var oStream: Text): WordBool;
function DeleteRecord(CustId: array of char; var iStream: Text; var oStream: Text): WordBool;

{*******************************************************************
    Callback Function declarations
 *******************************************************************}
function UserFieldSelection(hWnd: THandle; var field: StrField): WordBool;export;stdcall;
function VerifyData(hWnd: THandle; var field: StrField): WordBool;export;stdcall;
function EnterData(hWnd: THandle; var field: StrField; x,y,width,height: Integer): WordBool;export;stdcall;
function MsgCallback(hWnd: THandle; msg: Integer; wParam: Integer; lParam: LongInt): LongInt; export;stdcall;
function DrawPicture(hWnd: THandle; hDC: THandle; PictId, FieldId: Integer; var rect: TRect): WordBool; export;stdcall;


implementation

uses dmo_dlp2,dmo_dlp3,dmo_dlp4;

{$R *.DFM}

{$I frs_prot.pas FormPlus function prototypes}

procedure Tmain.FormCreate(Sender: TObject);
var
    i: Integer;
begin
   { Initialize the form designer argument structure}
    FormParm.open:=FALSE;           { all windows closed in the beginnin}
    FormParm.x:=0;                  { Initial X position of FORM edit windo}
    FormParm.y:=0;                  { Initial Y position of FORM edit windo}
    FormParm.width:=GetSystemMetrics(SM_CXSCREEN);        { Initial edit window widt}
    FormParm.height:=(GetSystemMetrics(SM_CYSCREEN)*9) div 10; { Initial edit window heigh}
    FormParm.ShowMenu:=TRUE;        { display men}
    FormParm.ShowVerBar:=TRUE;      { display vertical scroll ba}
    FormParm.ShowHorBar:=TRUE;      { display horizontal scroll bar (N/A with word wrap}
    FormParm.ShowToolbar:=TRUE;     { show toolbar icons}
    StrCopy(addr(FormParm.FileName),''); { Text file name if the input type is 'F}
    FormParm.hInst:=hInstance;      { Current application instant handl}
    FormParm.hPrevInst:=hPrevInst;  { Previous application instant handl}
    FormParm.hParentWnd:=handle;    { let this be the parent of the editor windo}
    FormParm.style:=WS_OVERLAPPEDWINDOW; {  Editor window styl}
    StrCopy(addr(FormParm.DataSetName),'CUSTOMER');


    {***** pass the pointer to the call back routine}
    { The field selection and verification routines must be included in the
        export section of your applications definition file }


    FormParm.UserSelection:=@UserFieldSelection; { field selection routin}
    FormParm.VerifyData:=@VerifyData;            { data verification routine}
    FormParm.EnterData:=@EnterData;              { custom data entry routine}
    FormParm.DrawPicture:=@DrawPicture;          { draw custom picture}

    {********** read field name for the customer file *****************}
    CurDataFile:='CUSTOMER.DB';
    CurDataDefFile:='CUSTOMER.DF';

    TempDataFile:='CUSTOMER.TMP';
    BackupFile:='CUSTOMER.BU';
    KeyField:=0;                     {key field in the customer file}

    if (False=ReadFields) then exit;

    { load the customer logo bitmap}
    logo:=TBitmap.Create;
    logo.LoadFromFile('logo.bmp');
    hLogoBM:=logo.handle;
    if (hLogoBM = 0) then
    begin
      ShowMessage('Error loading the logo bitmap');
      exit;
    end;


end;

procedure Tmain.Edit1Click(Sender: TObject);
begin
   FormParm.InDesignMode:=True;
   CallEditor;     { call the form editor}
end;


{ ***********************************************************************
   Select the form to edit and call the form editor
*************************************************************************}
procedure CallEditor;
var
    hFormWnd: THandle;
    FormFileName: string;
begin

    if (GetFormSelection(FormFileName,FormParm.InDesignMode)>=0) then {  select a form file}
    begin
       {*** let form designer use the default fonts ******}
       StrPCopy(FormParm.FileName,FormFileName);
       FormParm.FontTypeFace[0]:=#0;   { default font type faces for report}

       hFormWnd:=FrsForm(FormParm);    { call the form editor }
       FrsSetMsgCallback(FormParm.hFrWnd,@MsgCallback);{set a callback function to receive the close message}

       if (hFormWnd=0) then       { print error if any }
       begin
          ShowMessage('Error calling the form editor');
       end;
    end;
end;

{******************************************************************************
    GetFormSelection:
    Shows available report forms and let user select one.
    In form edit mode, the user has two additional selections to
    create a new report form.
******************************************************************************}
Function GetFormSelection(var CurFile: string; FormEdit: WordBool): Integer;
var
     select: integer;
begin

     TotalForms:=0;

     CurFile:=' ';

     GetFormFiles('*.FIC');          { get the report form file}

     if (FormEdit) then                { allow the user to create new form}
     begin
         NewForm:=TotalForms;      { append the new report selectio}
         TotalForms:=TotalForms+1;
         FormName[NewForm]:='New Form';
         FormFile[NewForm]:=' ';
     end
     else NewForm:=TotalForms;

     {***** show the file seletion box and let user select a file ***}
     SelectedForm:=-1;
     FormSel.ShowModal;

     if (SelectedForm >= 0) then
     begin
        CurFile:='';
        if (SelectedForm<>NewForm) then CurFile:=FormFile[SelectedForm];  { pass the file name}
     end;

     result:=SelectedForm;
end;
{******************************************************************************
    GetFormFiles:
    This routine scans the current directory for the files matching the
    specified template.
******************************************************************************}
Procedure GetFormFiles(template: string);
var
    done: Integer;
    hdr: StrFormHdr;
    blk: TSearchRec;
    InFile : file;
    BytesRead: Integer;
begin

    done:=findfirst(template,faReadOnly,blk);

    while(done=0) do
    begin
       if (TotalForms=MAX_FORMS) then break;

       FormFile[TotalForms]:=blk.Name;   { store the fiel name }
       done:=findnext(blk);              { get the next fill}

       {*************** get the form name **************************}
       AssignFile(InFile,FormFile[TotalForms]);
       Reset(InFile,1);

       BlockRead(InFile,hdr,sizeof(hdr),BytesRead);
       CloseFile(InFile);

       if (BytesRead<>sizeof(hdr)) or (hdr.FormSign<>FORM_SIGN ) then continue;

       FormName[TotalForms]:=StrPas(hdr.name);
       TotalForms := TotalForms + 1;
    end;
end;

{*****************************************************************************
    ReadFields:
    Read the field definitions for a file.  The argument specifies the index
    into the DataFile structure.
    The field definitions are stored in files with the extension .DF, whereas
    the data is stored in the files with the extension .DB.
*****************************************************************************}
function ReadFields: WordBool;
var
    line,CharReturn: string;
    CurLen,CurField,LineIdx: Integer;
    iStream: Text;
    CLine: array [0..255] of char;

begin

    CurField:=0;

    AssignFile(iStream,CurDataDefFile);
    Reset(iStream);

    while true do
    begin

       if (eof(iStream)) then break;  { end of file}
       {$I-}
       Readln(iStream, line);
       {$I+}

       if (IOResult>0) then
       begin
          line:=format('Error while reading file %s ',[CurDataDefFile]);
          ShowMessage(line);
          result:=FALSE;
          exit;
       end;

       LineIdx:=0;                       { prepare to scan the lin}
       CurLen:=length(line);

       { extract the field nam}
       StrPCopy(CLine,line);
       if (ExtractField(CLine,LineIdx,CurLen,CharReturn) = FALSE) then { extract field nam}
       begin
          line:=format('Invalid format, file: %s, field name',[CurDataDefFile]);
          ShowMessage(line);
          result:=FALSE;
          exit;
       end;

       CharReturn:=PStrTrim(CharReturn);              { trim spac}
       DataField[CurField].ShortName:=CharReturn;
       DataField[CurField].FullName:='CUSTOMER' + '->' + CharReturn;

       { extract the field widt}
       if (ExtractField(CLine,LineIdx,CurLen,CharReturn) = False) then { extract field nam}
       begin
          line:=format('Invalid format, file: %s, field width',[CurDataDefFile]);
          ShowMessage(line);
          result:=FALSE;
          exit;
       end;
       DataField[CurField].width:=StrToInt(CharReturn);

       { extract the field typ}
       if (ExtractField(CLine,LineIdx,CurLen,CharReturn) = False) then { extract field nam}
       begin
          line:=format('Invalid format, file: %s, field type',[CurDataDefFile]);
          ShowMessage(line);
          result:=FALSE;
          exit;
       end;

       if      (CharReturn[1]='T') then DataField[CurField].FieldType:=TYPE_TEXT
       else if (CharReturn[1]='N') then DataField[CurField].FieldType:=TYPE_NUM
       else if (CharReturn[1]='F') then DataField[CurField].FieldType:=TYPE_DBL
       else if (CharReturn[1]='D') then DataField[CurField].FieldType:=TYPE_DATE
       else if (CharReturn[1]='C') then DataField[CurField].FieldType:=TYPE_CHECKBOX
       else if (CharReturn[1]='R') then 
         begin
           DataField[CurField].FieldType:=TYPE_RADIO;
           DataField[CurField].RadioGroup:=integer(CharReturn[2]);
         end
       else if (CharReturn[1]='P') then DataField[CurField].FieldType:=TYPE_PICT
       else
       begin
          line:=format('Invalid format, file: %s, field type(a)',[CurDataDefFile]);
          ShowMessage(line);
          result:=FALSE;
          exit;
       end;

       { extract the default decimal place}
       if (ExtractField(CLine,LineIdx,CurLen,CharReturn) = False) then { extract field nam}
       begin
          line:=format('Invalid format, file: %s, field DecPlaces',[CurDataDefFile]);
          ShowMessage(line);
          result:=FALSE;
          exit;
       end;
       DataField[CurField].DecPlaces:=StrToInt(CharReturn);

       CurField:=CurField+1;

    end;

    {END FILE}
    CloseFile(iStream);
    TotalFields:=CurField;

    result:=TRUE;
end;

{******************************************************************************
    ExtractField:
    This routine scans a text line to extract the next field.
    The fields are assumed to be of character type.
******************************************************************************}
function ExtractField(line: pChar;var idx: integer;LineLen: Integer;var CharReturn: string): WordBool;
var
  quote,comma,SaveChar,space: char;
  ptr: pChar;
  TempString: array [0..255] of char;
  i,j: Integer;
begin

    result:=False;                        { Initialize the result value}
    quote:='"';
    comma:=',';
    space:=' ';

    i:=idx;
    while ((i<LineLen) and (line[i]=space)) do i := i+1;  { go past the space}

    if (i>=LineLen) then exit;             { past the end of the lin}

    if (line[i]=quote) then
    begin
       i := i+1;                                 { skip over the first quot}
       ptr:=StrScan(addr(line[i]),quote);
       if (ptr=nil) then exit;

       j:=1;
       while ((ptr[j]<>',') and (ptr[j]<>#0)) do j:=j+1;{ locate the next comm}

       SaveChar:=ptr[0];                     { extract the strin}
       ptr[0]:=#0;
       StrECopy(TempString,addr(line[i]));
       ptr[0]:=SaveChar;
       idx:=i+strlen(TempString)+1+j;         { index to the next field      }
    end
    else
    begin
       ptr:=StrScan(addr(line[i]),comma);
       if (nil=ptr) then ptr:=addr(line[LineLen]);  { field spans the end of the lin}

       SaveChar:=ptr[0];                     { extract the strin}
       ptr[0]:=#0;
       strECopy(TempString,addr(line[i]));
       ptr[0]:=SaveChar;
       idx:=i+strlen(TempString)+1;           { index to the next field      }
    end;

    CharReturn:=StrPas(TempString);

    result:=TRUE;
end;


{*******************************************************************
    Report Executer Interface
 *******************************************************************}
procedure Tmain.Run1Click(Sender: TObject);
begin
   FormParm.InDesignMode:=False;    {invoke the executer}
   CallEditor;     { call the form editor}
end;

{************************************************************************
          Callback function
*************************************************************************}

{******** trap FRS_CLOSE message ************}
function MsgCallback(hWnd: THandle; msg: Integer; wParam: Integer; lParam: LongInt): LongInt;
begin
   if (msg=FRS_CLOSE) then FormParm.open:=FALSE;
end;

{*****************************************************************************
    UserFieldSelection:
    This routine is called by the dll to allow user to select
    a data field.  This routine can be programmed by your application in
    any way as long as it returns the data about the selected field using
    the argument pointer.  If the user chose not to select a field after all,
    the function should return with a FALSE value. Otherwise it should return
    with a TRUE value.

    In this routine, we will allow the user to first select a field from 
    the customer file.  The required data about the
    selected field is filled into the 'field' structure. Your program may
    also optionally fill other remaining 'field' structure variables.

    The first parameter contains the handle of the Form Editor window.
*****************************************************************************}
function UserFieldSelection(hWnd: THandle; var field: StrField): WordBool;
begin

    result:=False;
    CurField:=-1;

    while CurField<0 do
    begin
      { SELECT FIELD}
      FieldSel.ShowModal;  { select a data field}

      if (CurField<0) then exit;
    end;

    { fill the required 'field' variable}

    StrPCopy(field.name,DataField[CurField].FullName); { field nam}
    field.FieldType:=DataField[CurField].FieldType;             { alpha/num et}
    field.width:=DataField[CurField].width;           { display widt}
    field.DecPlaces:=DataField[CurField].DecPlaces;   { decimal places for displa}
    field.RadioGroup:=DataField[CurField].RadioGroup; { group number for the radio field}

    if (DataField[CurField].FullName='CUSTOMER->RATING') then
       field.flags := field.flags or FLAG_CUSTOM_DATA;

    { specify new paragraph indicator field.  Used only for a word/wrap
      text type field}
    field.ParaChar[0]:='|';

    {***** fill up these OPTIONAL fields also. This information will be
            used by our report executer demo program to identfy the
            fields quickly.  ****}

    field.FieldId:=CurField;                  { information onl}

    result:=True;
end;

{*****************************************************************************
    VerifyData:
    This routine is called by the dll to validate the data for a field.
    The field name is given by the 'name' variable in the StrField structure. 
    It contains the full name including the file prefix (if your application allows
    it). The input field is always in the upper case.
    The field data is provided in the NumData,DblData or the CharData variables.

    The function should return TRUE if the field is valid, otherwise it 
    should return a FALSE value.
*****************************************************************************}
function VerifyData(hWnd: THandle; var field: StrField): WordBool;
var
   CustId: array [0..9] of char;
   NumData: LongInt;
   DblData: double;
begin

    result:=False;

    {Handle the system pushbutton events}
    if (field.source=SRC_SYS) then
    begin
       {make sure that the customer id exists in this form}
       if (not FrsGetFieldData(hWnd,'CUSTOMER->CUST_ID',0,NumData,DblData,CustId)) then
       begin
          FrsShowMessage(hWnd,'Customer Id Field Missing!');
          exit;
       end;

       {Locate and show the next customer}
       if (field.SysIdx=SYS_FIND_NEXT) then
       begin
          if (not ReadNextRecord(CustId)) then
          begin
            FrsShowMessage(hWnd,'No More Customers Found!');
            exit;
          end;
          ShowRecord(hWnd,False);  {Show the current Record}
          result:=True;
          exit;
       end;

       {Locate and show the previous customer}
       if (field.SysIdx=SYS_FIND_PREV) then
       begin
          if (not ReadPrevRecord(CustId)) then
          begin
            FrsShowMessage(hWnd,'No More Customers Found!');
            exit;
          end;
          ShowRecord(hWnd,False);  {Show the current Record}
          result:=True;
          exit;
       end;

       {Read and display a customer record}
       if (field.SysIdx=SYS_VIEW_DATA) then
       begin
          if (not ReadRecord(CustId)) then
          begin
            FrsShowMessage(hWnd,'Invalid Customers Id!');
            exit;
          end;
          ShowRecord(hWnd,False);  {Show the current Record}
          result:=True;
          exit;
       end;

       {Verify that a customer key exists in the file}
       if (field.SysIdx=SYS_VERIFY_KEY) then
       begin
          if (ReadRecord(CustId)) 
              then FrsShowMessage(hWnd,'Customer Record Found')
              else FrsShowMessage(hWnd,'Customer Record Not Found');
          result:=True;
          exit;
       end;

       {Add a customer record}
       if (field.SysIdx=SYS_ADD_KEY) then
       begin
          if (StrLen(CustId)=0) then 
          begin
             FrsShowMessage(hWnd,'Blank Customer Id Not Allowed');
             exit;
          end;
          {check if record already exists in the file}
          if (ReadRecord(CustId)) then
          begin 
              FrsShowMessage(hWnd,'This Customer Id Already Exists in the File');
              exit;
          end;
          {add the record to the file}
          if (WriteRecord(hWnd,CustId,'A')) then
          begin
             FrsShowMessage(hWnd,'Customer Record Added');
             result:=True;
          end
          else FrsShowMessage(hWnd,'Error adding Customer Id!');

          exit;
       end;

       {update the current customer record}
       if (field.SysIdx=SYS_UPDATE_DATA) then
       begin
          {check if record exists in the file}
          if (not ReadRecord(CustId)) then
          begin 
              FrsShowMessage(hWnd,'This Customer Id does Not Exist in the File');
              exit;
          end;
          {update the record to the file}
          if (WriteRecord(hWnd,CustId,'U')) then
          begin
             FrsShowMessage(hWnd,'Customer Record Updated');
             result:=True;
          end
          else FrsShowMessage(hWnd,'Error updating the Customer Record!');

          exit;
       end;

       {delete the current customer record}
       if (field.SysIdx=SYS_DELETE_DATA) then
       begin
          {check if record exists in the file}
          if (not ReadRecord(CustId)) then
          begin 
              FrsShowMessage(hWnd,'This Customer Id does Not Exist in the File');
              exit;
          end;
          {delete the record to the file}
          if (WriteRecord(hWnd,CustId,'D')) then
          begin
             FrsShowMessage(hWnd,'Customer Record Deleted');
             ShowRecord(hWnd,True);   {show a blank record now}
             result:=True;
          end
          else FrsShowMessage(hWnd,'Error deleting the Customer Record!');

          exit;
       end;


    end;


    result:=TRUE; 
end;

{*****************************************************************************
    EnterData:
    The dll calls this routine when the user clicks on the fields which are
    marked with FLAG_CUSTOM_DATA flag. (this flag can be set in the 
    UserFieldSelection function).  Your application prompts the user for
    data entry in this function.
*****************************************************************************}
function EnterData(hWnd: THandle; var field: StrField; x,y,width,height: Integer): WordBool;
begin

   { accept the customer rating field }
   if (StrIComp(field.name,'CUSTOMER->RATING')=0) then
   begin
      {pass the current rating value to the dialog box}
      if      (StrIComp(field.CharData,'A')=0) then DlgInt:=0
      else if (StrIComp(field.CharData,'B')=0) then DlgInt:=1
      else if (StrIComp(field.CharData,'C')=0) then DlgInt:=2
      else                                          DlgInt:=3;

      GetRating.ShowModal;  { get the customer rating}

      if (DlgInt<0) then exit;  {pressed cancel}

      {return the selected rating value}
      if      (DlgInt=0) then StrCopy(field.CharData,'A')
      else if (DlgInt=1) then StrCopy(field.CharData,'B')
      else if (DlgInt=2) then StrCopy(field.CharData,'C')
      else                    StrCopy(field.CharData,'X');
   end;

end;

{*****************************************************************************
    DrawPicture:
    This routine is called by the report executor to draw a specified
    picture type field.  The first argument specifies the device context
    of the reporting device.  If the report output is directed to a printer,
    this device context belongs to a printer, otherwise it specifies a
    device context for a metafile.  You application should draw the picture
    on this device context within the specified rectangle (last argument).

    The device context is in ANISOTROPIC mode.  The resolution in the X and
    Y direction is given by the UNITS_PER_INCH constant.

    The second argument is the picture id.  The third and fourth arguments
    are the file and field id for the picture field.

    The function returns TRUE if successful.

    In this demo program, this routine draws a logo for a given picture id.
    This program uses only one bitmap, and draws different part of the same
    bitmap for different picture id.

*****************************************************************************}
function DrawPicture(hWnd: THandle; hDC: THandle; PictId, FieldId: Integer; var rect: TRect): WordBool;
var
    bm: StrBitmap;
    SourceWidth,SourceX: Integer;
    PictFile: array [0..100] of char;
begin
    
    result:=FALSE;
    if (PictId<1) then exit;
    if (PictId>10) then exit;   

    { get the bitmap informati}
    GetObject(hLogoBM,sizeof(StrBitmap),addr(bm));

    { Select part of the bitmap to display for this picture }
    SourceWidth:=bm.bmWidth div 10;          { divide picture into 10 equal parts}
    SourceX:=SourceWidth*(PictId-1);

    { copy the bitmap}

    StretchBlt(hDC,rect.left,rect.top,rect.right-rect.left,rect.bottom-rect.top,
                 logo.canvas.handle,SourceX,0,SourceWidth,bm.bmHeight,SRCCOPY);
  
    result:=TRUE;
end;


{*******************************************************************
    File IO routines
    These routines reads and updates the sample database file which
    is a flat text file.
 *******************************************************************}

{***********************************************************************
     Read a record from the database
 ***********************************************************************}
function ReadRecord(CustId: array of char): WordBool;
var
   iStream: Text;
   RecFound: WordBool;
begin

   AssignFile(iStream,CurDataFile);  {open the current data file}
   Reset(iStream);

   RecFound:=False;

   while (ExtractNextRecord(iStream)) do
   begin
      if (StrIComp(DataField[KeyField].TextData,addr(CustId))=0) then  {record found}
      begin
         RecFound:=True;
         break;
      end;
   end;

   CloseFile(iStream);
   result:=RecFound;
end;

{***********************************************************************
     Read next record from the database
 ***********************************************************************}
function ReadNextRecord(CustId: array of char): WordBool;
var
   iStream: Text;
   RecFound: WordBool;
begin

   AssignFile(iStream,CurDataFile);  {open the current data file}
   Reset(iStream);

   RecFound:=False;

   while (ExtractNextRecord(iStream)) do
   begin
      if (StrIComp(DataField[KeyField].TextData,addr(CustId))>0) then  {record found}
      begin
         RecFound:=True;
         break;
      end;
   end;

   CloseFile(iStream);
   result:=RecFound;
end;

{***********************************************************************
     Read previous record from the database
 ***********************************************************************}
function ReadPrevRecord(CustId: array of char): WordBool;
var
   iStream: Text;
   PrevCustId: array [0..9] of char;
begin

   AssignFile(iStream,CurDataFile);  {open the current data file}
   Reset(iStream);

   StrCopy(PrevCustId,'');

   while (ExtractNextRecord(iStream)) do
   begin
      if (StrIComp(DataField[KeyField].TextData,addr(CustId))>=0) then  break; {record found}
      StrCopy(PrevCustId,DataField[KeyField].TextData);
   end;

   CloseFile(iStream);

   if (StrLen(PrevCustId)>0) then result:=ReadRecord(PrevCustId)
   else result:=False;
end;

{***********************************************************************
     Write, update or delete a record in the database
 ***********************************************************************}
function WriteRecord(hWnd: THandle; CustId: array of char; op: String): WordBool;
var
   iStream,oStream: Text;
   pBackupFile: array [0..63] of char;
begin

   AssignFile(iStream,CurDataFile);  {assign the database file}
   Reset(iStream);                   {open for read}

   {open the temporary output file}
   AssignFile(oStream,TempDataFile);  {assign a temporary file}
   Rewrite(oStream);                 {open for write}

   if (op='A') then result:=AddRecord(hWnd,CustId,iStream,oStream);
   if (op='U') then result:=UpdateRecord(hWnd,CustId,iStream,oStream);
   if (op='D') then result:=DeleteRecord(CustId,iStream,oStream);


   CloseFile(iStream);
   CloseFile(oStream);

   {rename the files}
   StrPCopy(pBackupFile,BackupFile);
   DeleteFile(pBackupFile);
   RenameFile(CurDataFile,BackupFile);
   RenameFile(TempDataFile,CurDataFile);

   result:=result;
end;

{***********************************************************************
     Add a record to the database
 ***********************************************************************}
function AddRecord(hWnd: THandle; CustId: array of char; var iStream: Text; var oStream: Text): WordBool;
var
   SaveField: array [0..MAX_FIELDS] of StrDataField;
   added: WordBool;
   RecordRead: WordBool;
   i: Integer;
begin

   result:=False;
   added:=False;
   RecordRead:=False;

   while (True) do
   begin
      RecordRead:=ExtractNextRecord(iStream);
      
      if (not RecordRead) then  {end of input file}
      begin
         if (added) then result:=True       {our record already added}
         else
         begin
            GetRecordFromScreen(hWnd);          {get the field values from the screen}
            result:=WriteCurRecord(oStream);    {append the new record}
            if (result) then ShowRecord(hWnd,True);
         end;
         exit;
      end;

      if (StrIComp(DataField[KeyField].TextData,addr(CustId))<0) then  {write the existing records}
      begin
         result:=WriteCurRecord(oStream);    {copy the existing record}
         if (not result) then exit;
      end
      else           {keys larger than the new record}     
      begin
         if (not added) then   {write the new record}
         begin
            {save the current record}
            for i:=0 to TotalFields - 1 do SaveField[i]:=DataField[i];
            
            GetRecordFromScreen(hWnd);          {get the field values from the screen}
            result:=WriteCurRecord(oStream);    {append the new record}
            if (result) then ShowRecord(hWnd,True);
            added:=True;
            
            {restore the current record}
            for i:=0 to TotalFields - 1 do DataField[i]:=SaveField[i];
         end;
         
         {write the current record}
         result:=WriteCurRecord(oStream);
         if (not result) then exit;
      end;

      result:=False;
   end;

end;

{***********************************************************************
     update a record in the database
 ***********************************************************************}
function UpdateRecord(hWnd: THandle; CustId: array of char; var iStream: Text; var oStream: Text): WordBool;
var
   RecordRead,updated: WordBool;
   i: Integer;
begin

   result:=False;
   updated:=False;
   RecordRead:=False;

   while (True) do
   begin
      RecordRead:=ExtractNextRecord(iStream);
      
      if (not RecordRead) then  {end of input file}
      begin
         result:=updated;      {our record already added}
         exit;
      end;

      if (StrIComp(DataField[KeyField].TextData,addr(CustId))=0) then  {update this record}
      begin
         GetRecordFromScreen(hWnd);          {get the field values from the screen}
         updated:=True;
      end;

      {write the current record}
      result:=WriteCurRecord(oStream);
      if (not result) then exit;
   end;

end;

{***********************************************************************
     delete a record in the database
 ***********************************************************************}
function DeleteRecord(CustId: array of char; var iStream: Text; var oStream: Text): WordBool;
var
   RecordRead,deleted: WordBool;
   i: Integer;
begin

   result:=False;
   deleted:=False;
   RecordRead:=False;

   while (True) do
   begin
      RecordRead:=ExtractNextRecord(iStream);
      
      if (not RecordRead) then  {end of input file}
      begin
         result:=deleted;      {our record already added}
         exit;
      end;

      if (StrIComp(DataField[KeyField].TextData,addr(CustId))=0) then  {update this record}
         deleted:=True
      else 
      begin
         {write the current record}
         result:=WriteCurRecord(oStream);
         if (not result) then exit;
      end;
   end;

end;

{***********************************************************************
     Get field values from the screen
 ***********************************************************************}
function GetRecordFromScreen(hWnd: THandle): WordBool;
var
  i: Integer;
begin
     {get the current values from the screen}
     for i:=0 to TotalFields - 1 do
     begin
        if (not FrsGetFieldData(hWnd,'',i,DataField[i].NumData,DataField[i].DblData,addr(DataField[i].TextData))) then
        begin
           DataField[i].NumData:=0;  {use 0 values for the fields that are not on the screen}
           DataField[i].DblData:=0;
           StrCopy(DataField[i].TextData,'');
        end;
     end;

     result:=True;
end;

{***********************************************************************
     write the current record to the output file
 ***********************************************************************}
function WriteCurRecord(var oStream: Text): WordBool;
var
  i: Integer;
  line: array [0..300] of char;
  quote: array [0..1] of char;
  comma: array [0..1] of char;
  str: string;
  TempStr: array [0..10] of char;
begin

  StrCopy(line,'');
  quote[0]:=#34;    { quoteed string}
  quote[1]:=#0;
  comma[0]:=#44;    { string that only contains a comma}
  comma[1]:=#0;

  {build the text line to write}
  for i:=0 to TotalFields - 1 do
  begin
     if (i>0) then StrCat(line,comma);  { write the comma delimiter}

     {append a field data string}
     if (DataField[i].FieldType=TYPE_TEXT) then
     begin
        StrCat(line,quote);
        StrCat(line,DataField[i].TextData);
        StrCat(line,quote);
     end
     else if ((DataField[i].FieldType=TYPE_RADIO) or (DataField[i].FieldType=TYPE_CHECKBOX)) then
     begin
        if (DataField[i].NumData<>0)
            then StrCat(line,'Y')
            else StrCat(line,'N');
     end
     else if (DataField[i].FieldType=TYPE_DBL) then
     begin
        str:=Format('%f',[DataField[i].DblData]);
        StrPCopy(TempStr,str);
        StrCat(line,TempStr);
     end
     else
     begin
        str:=IntToStr(DataField[i].NumData);
        StrPCopy(TempStr,str);
        StrCat(line,TempStr);
     end;
  end;

  Writeln(oStream,line);

  result:=True;
end;

{***********************************************************************
    Extract next data record and fill the field values into the DataField
    structure
 ***********************************************************************}
function ExtractNextRecord(var iStream: Text): WordBool;
var
    line,TempString: string;
    LineIdx: Integer;
    CurLen: Integer;
    CLine: array [0..255] of char;
    CString1: array [0..255] of char;
    i: Integer;
begin

    if (eof(iStream)) then { end of file}
    begin
       result:=False;
       exit;
    end;
    
    {$I-}
    Readln(iStream, line);
    {$I+}

    if (IOResult>0) then
    begin
       ShowMessage('Error while reading the data file');
       result:=FALSE;
       exit;
    end;

    LineIdx:=0;                       { prepare to scan the lin}
    CurLen:=length(line);

    { extract the field values}
    StrPCopy(CLine,line);

    for i := 0 to TotalFields - 1 do
    begin
       { extract the field value}
       if (ExtractField(CLine,LineIdx,CurLen,TempString)=False) then 
       begin
          result:=False;
          exit;
       end;

       {transfer the data value}
       if (DataField[i].FieldType=TYPE_TEXT) then
       begin
           StrPCopy(CString1,TempString);
           if (strlen(CString1)>DataField[i].width) then CString1[DataField[i].width]:=#0; { truncate oversize data}
           StrCopy(DataField[i].TextData,CString1);
       end;
       if (DataField[i].FieldType=TYPE_NUM) then
           DataField[i].NumData:=StrToInt(PStrTrim(TempString));
       if (DataField[i].FieldType=TYPE_DBL) then
           DataField[i].DblData:=StrToFloat(PStrTrim(TempString));
       if (DataField[i].FieldType=TYPE_DATE) then
           DataField[i].NumData:=StrToInt(PStrTrim(TempString)); { date in YYMMDD or YYYYMMDD}
       if (DataField[i].FieldType=TYPE_PICT) then
           DataField[i].NumData:=StrToInt(PStrTrim(TempString)); { date in YYMMDD or YYYYMMDD}
       if ((DataField[i].FieldType=TYPE_CHECKBOX) or (DataField[i].FieldType=TYPE_RADIO)) then
       begin
          if ((TempString[1]='Y') or (TempString[1]='y'))
          then DataField[i].NumData:=1
          else DataField[i].NumData:=0;
       end;
    end;

    result:=True;
end;

{***********************************************************************
     Show the current record
 ***********************************************************************}
function ShowRecord(hWnd: THandle; initialize: WordBool): WordBool;
var
  i: Integer;
begin

  for i:=0 to TotalFields-1 do
  begin
    if (initialize) then 
    begin
       DataField[i].NumData:=0;
       DataField[i].DblData:=0;
       StrECopy(DataField[i].TextData,'');
    end;
    { set this field}
    FrsSetFieldData(hWnd,'',i,DataField[i].NumData,DataField[i].DblData,addr(DataField[i].TextData),False);
  end;

  FrsRepaint(hWnd,PAINT_WIN);  {repaint the window}
end;


{*******************************************************************
    Helper routines
 *******************************************************************}
{***********************************************************************
     Trim the spaces from the left and right of a string
 ***********************************************************************}
function PStrTrim(InString: string): string;
var
  i,len: Integer;
begin
  { trim the spaces from the beginning of the string}
  len:=length(InString);

  for i:=1 to len do
  begin
    if (InString[i]<>' ') then break;
  end;
  if (i>1) then delete(InString,1,i-1);

  {trim the spaces from the end of the string }
  len:=length(InString);

  for i:=len downto 0 do
  begin
     if (InString[i]<>' ') then break;
  end;

  if (i<len) then delete(InString,i+1,len-i);

  result:=InString;
end;

end.
