/*****************************************************************************
    Form Plus By Sub Systems, Inc.

    This file should be included into your application modules which call
    the Frsort Right interface functions.
*****************************************************************************/
#if defined (_WIN32)
   #if !defined(WIN32)
     #define WIN32
   #endif
#endif
/******************************************************************************
    WIN32 specific defines
*******************************************************************************/
#if defined (WIN32)
   #define huge
   #define _export
   #define FR_CLASS  "FrsClass32"
#else
   #define huge huge 
   #define FR_CLASS  "FrsClass"
#endif


/****************************************************************************
   Control style bits
*****************************************************************************/
#define FRS_DESIGN_MODE     0x1
#define FRS_HSCROLL         0x2
#define FRS_VSCROLL         0x4
#define FRS_MENU            0x8
#define FRS_TOOLBAR         0x100
#define FRS_USE_PARAMS      0x200
#define FRS_INVISIBLE       0x400
#define FRS_NUM_STYLES      7

#define CB_USER_SELECTION   1
#define CB_VERIFY_DATA      2
#define CB_DRAW_PICTURE     3
#define CB_ENTER_DATA       4

#define FFLAG_RETURN_MSG_ID      0x1
#define FFLAG_SEND_SYS_FIELD_MSG 0x2     // send message/for system field selection, SysIdx is set to -2 

/****************************************************************************
   Instructions for packing the following structure
*****************************************************************************/
#ifndef RC_INVOKED
   #pragma pack(1)
#endif

typedef int (FAR PASCAL _export *USER_SELECTION)(HWND, struct StrField huge *); 
typedef BOOL (FAR PASCAL _export *VERIFY_DATA)(HWND, struct StrField huge *); 
typedef int (FAR PASCAL _export *DRAW_PICTURE)(HWND, HDC, int, int, RECT far *); 
typedef BOOL (FAR PASCAL _export *ENTER_DATA)(HWND, struct StrField huge *,int,int,int,int); 

/*****************************************************************************
   The parameter structure definition that is used by your application
   to specify the operation parameters and text data to the 'form' routine.
   For an example for using this structure, refer to the demo.c file.
*****************************************************************************/

struct StrForm { 
       BOOL   InDesignMode;// TRUE for the form designer mode, and FALSE for
                         // data input mode
       int    x;         // Initial x position of the editing window,
                         // you may specify CW_USEDEFAULT to use default values.
       int    y;         // Initial y position of the editing window.
       int    width;     // Initial width of the window in device units,
                         // you may specify CW_USEDEFAULT to use default values.
       int    height;    // Initial height of the editing window.  When you
                         // use CW_USEDEFAULT for width, the height parameter is 
                         // ingnored.*/

       USER_SELECTION UserSelection; 
                           /*This callback function is called in the desgin mode
                           when the user wishes to insert a data field into the
                           form. The first argument is a pointer to the field
                           structure. Your application returns the data for 
                           the chosen field through the first parameter.
                           The second argument indicates 
                           the sort field number. If it is equal to zero,  
                           it means that the field being sought is not a sort 
                           field. This function should return a TRUE value if 
                           successful. 
                           */

       VERIFY_DATA VerifyData;
                          /* This callback function is called in the run
                          mode when the user inputs data into a field. The newly
                          entered data for the field is returned by the NumData
                          (for numeric, date, radio button, and checkbox), 
                          DblData (for the floating numeric field) and CharData
                          pointer (for the text field). Your application returns
                          TRUE if the field is valid, otherwise it returns
                          a FALSE value.  Your application can also use the
                          FrsShowMessage function to display a message at this
                          point*/ 

       DRAW_PICTURE  DrawPicture;
                          /* This callback function is called in the run mode
                             to draw a PICT type field. */

       ENTER_DATA EnterData;
                          /* This callback function is called in the run
                          mode for the fields which have the FLAG_CUSTOM_DATA
                          flag set.  For these fields, your application helps
                          the user to select or enter data for the field, the
                          data is passed using NumData,DblData or the CharData
                          member variables.*/


       char file[132];  // form file name. If an existing file is specified,
                        // the following fields are ignored. 
                                            
       char DataSetName[20];/* (Specify for a new file) Your application can 
                           specify a data set name which can be used to
                           associate the application data to the form.  This
                           is an optional field. For exising files and in the
                           run mode, the data set name is returned using 
                           this field.*/

        BOOL   ShowMenu;  // show the menu bar ? 
        BOOL   ShowHorBar;// show the horizonatal scroll bar 
        BOOL   ShowVerBar;// show the vertical scroll bar 
        BOOL   ShowToolbar;// show tool bar

        HANDLE hInst;     //  Handle of the current instanaces. 
        HANDLE hPrevInst; //  Handle of the previous instances. 
        HWND   hParentWnd;// Handle to the parent window 
        HWND   hFrWnd;    //  Form main window handle, will be filled by RE later  
        DWORD  style;     //  Editor window style 
        char   FontTypeFace[32]; // Default type face, example: TmwRmn Courier, etc 
        BOOL   open;      // TRUE indicates an open window (parameter block in use)
        BOOL   modified;  // TRUE when the file modified, and needs to be saved 
       };


/*****************************************************************************
                       Global Constants
*****************************************************************************/

#if defined (WIN32)
  #define FORM_SIGN       0xDFBA
#else
  #define FORM_SIGN       0xDFBC
#endif

#define UNITS_PER_INCH  250
#define NAME_WIDTH      50

#define SRC_APPL        0
#define SRC_SYS         1
#define SRC_CONST       2
#define SRC_NONE        3

#define TYPE_NUM        1
#define TYPE_DBL        2
#define TYPE_TEXT       3
#define TYPE_DATE       4
#define TYPE_PICT       5
#define TYPE_RADIO      6
#define TYPE_CHECKBOX   7
#define TYPE_PUSHBUTTON 8

#define DT_MMDDYY       0
#define DT_DDMMYY       1
#define DT_MMDDYYYY     2
#define DT_MMMDDYYYY    3

#define FLAG_TRIM       0x1
#define FLAG_SUP_ZERO   0x2
#define FLAG_PAD_ZERO   0x4
#define FLAG_CAPS       0x8
#define FLAG_FIRST_CAP  0x10
#define FLAG_SMALL      0x20
#define FLAG_COMMA      0x40
#define FLAG_WRAP       0x80
#define FLAG_WORD_WRAP  0x100
#define FLAG_CUSTOM_DATA 0x200
#define FLAG_FLEX_SIZE  0x400
#define FLAG_SHARED     0x1000
#define FLAG_PROTECT    0x2000
#define FLAG_3D_OUTLINE 0x4000

// Systems Fields
#define SYS_DATE        0
#define SYS_TIME        1
#define SYS_ADD_KEY     2
#define SYS_VERIFY_KEY  3
#define SYS_VIEW_DATA   4
#define SYS_UPDATE_DATA 5
#define SYS_DELETE_DATA 6
#define SYS_FIND_NEXT   7
#define SYS_FIND_PREV   8
#define SYS_RESET       9
#define MAX_SYS_FIELDS  10

#define PAINT_ITEMS     2
#define PAINT_WIN       3
#define PAINT_PARTIAL_WIN  5

#define ERR_NO_FILE     1
#define ERR_NO_DEVICE   2
#define ERR_NO_MEM      3
#define ERR_BAD_EXP     4
#define ERR_SUSPEND     5
#define ERR_ZERO_DIVIDE 6
#define ERR_TYPE_MISMATCH 7
#define ERR_INCOMPLETE  8
#define ERR_DUPLICATE   9
#define ERR_PRINTER     10
#define ERR_IO          11
#define ERR_DISPLAY     12
#define ERR_WRAP        13
#define ERR_FONT        14
#define ERR_OTHER       15

#define ERR_BAD_WND     16
#define ERR_NO_FRS_ID   17
#define ERR_BAD_FRS_ID  18
#define ERR_NO_OUTFILE  19
#define ERR_NO_TER      20
#define ERR_IN_TER      21

typedef long (FAR PASCAL _export *MSG_CALLBACK)(HWND,UINT,WPARAM,LPARAM);
typedef long (FAR PASCAL _export *VBX_CALLBACK)(HWND,UINT,WPARAM,LPARAM);

/******************************************************************************
                        Form Header Structure
******************************************************************************/
struct StrFormHdr {
           unsigned FormSign;     // Form File Signature 
           
           char name[NAME_WIDTH+2]; // report name 

           char DataSetName[20];  // Your application can specify a data set 
                                  // name which can be used to associate the 
                                  // application data to the form.  This
                                  // is an optional information.
           
           int   ItemCount;       // screen items in the form template 
           int   TotalFields;      // total number of fields 
           int   FontCount;       // number of entries in the font table 
           int   SectionCount;    // number of form parts used

           float LeftMarg;        // margins in inches 
           float RightMarg;
           float TopMarg;
           float BottomMarg;

           char PrtName[NAME_WIDTH+2],      // name of the printer 
                PrtDriver[NAME_WIDTH+2];    // printer driver name 

           unsigned flags;        // RFLAG_ series flags 

           int  DateFmt;          // 0=MM/DD/YY, 1=DD/MM/YY 
           
           int  RulerType;        // RULER_OFF,RULER_INCH,RULER_CM
           
           int  SecBannerHeight;  // height (logical units) of the section banner                        
           int  FileFormatId;     // records the file format changes
           #if defined (WIN32)
              char   reserved[142];  // reserved
           #else
              char   reserved[144];  // reserved
           #endif
       };

/******************************************************************************
                        Field Structure
******************************************************************************/
struct StrField {                 // define each field 
         int source;              // source of field data: application,calculation,system, constant etc 

         char name[NAME_WIDTH+2]; // field name 
         int FieldId;             // another optional id that may be defined by the calling application 
         int type;                // numeric/alphanumeric/logical/date 
         int width;               // field data width as stored in your database
         int DecPlaces;           // decimal places for numeric fields 
         int AllowChanges;        // Allow modification of the following fields 

         int InUse;               // TRUE=in use, FALSE=not in use 
         unsigned flags;          // flags 
         int SysIdx;              // index into the system field table for system fields 

         int  DateFmt;            // date format   
         char DateDelim[2];       // date delimiter character, i.e. / or -
         char ParaChar[2];       // specify the new paragraph indicator character 
          
         char CurrencySymbol[4];  // currency symbol 

         char NegSignPrefix[4];   // negative sign prefix 
         char NegSignSuffix[4];   // negative sign suffix 
         char PosSignPrefix[4];   // positive sign prefix 
         char PosSignSuffix[4];   // positive sign suffix 

         LPSTR  CharData;         // character data, pointer to an object of size = field.width+1 
         long   NumData;          // numeric data (long) 
         double DblData;          // numeric data for field = TYPE_DBL 

         int   RadioGroup;        // group number for the radio fields

         int   SectId;            // section that holds the field (report time only)
         int   misc;              // used for miscellaneous purposes 

         int   UseCount;          // use count for the shared fields

         #if defined (WIN32)
            char   reserved32[10];// reserved
         #else
            char   reserved[8];  // pad to 128 bytes
         #endif
       };

/****************************************************************************
   Instructions to resume the default structure packing.
*****************************************************************************/
#ifndef RC_INVOKED
   #pragma pack()
#endif

/******************************************************************************
                        Calleable Function Prototypes
   When calling FRS from a C program, leave the FRS_CPLUSPLUS symbol undefined.

   When calling FRS from a C++ program, define the FRS_CPLUSPLUS as following:

   #define FRS_CPLUSPLUS extern "C"
   #include "rep.h"
******************************************************************************/
#ifndef FRS_CPLUSPLUS
   #if defined(__cplusplus) 
      #define FRS_CPLUSPLUS extern "C"
   #else
      #define FRS_CPLUSPLUS
   #endif
#endif

FRS_CPLUSPLUS HWND WINAPI _export FrsForm(struct StrForm far *);
FRS_CPLUSPLUS HWND WINAPI _export FrsGetParent(HWND);
FRS_CPLUSPLUS int  WINAPI _export FrsSetMsgCallback(HWND,MSG_CALLBACK);
FRS_CPLUSPLUS LPVOID WINAPI _export FrsGetParentPtr(HWND);
FRS_CPLUSPLUS BOOL WINAPI _export FrsSetParentPtr(HWND,LPVOID);

FRS_CPLUSPLUS BOOL  WINAPI _export FrsShowMessage(HWND,LPSTR);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsGetFieldData(HWND,LPSTR,int,long far *,double far *,LPSTR);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsSetFieldData(HWND,LPSTR,int,long,double,LPSTR,BOOL);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsRepaint(HWND,int);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsGetModified(HWND);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsSetModified(HWND,BOOL);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsMenuEnable(HWND,UINT);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsMenuSelect(HWND,UINT);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsSetCallback(HWND,int,LPVOID);
FRS_CPLUSPLUS DWORD WINAPI _export FrsSetFlags(HWND,BOOL,DWORD);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsRead(HWND,LPSTR);  
FRS_CPLUSPLUS BOOL  WINAPI _export FrsSave(HWND,LPSTR);       
FRS_CPLUSPLUS BOOL  WINAPI _export FrsLoadControl(void);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsCommand(HWND,UINT);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsQueryExit(HWND);       
FRS_CPLUSPLUS BOOL  WINAPI _export FrsGetSelectedField(HWND,struct StrField far *);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsSetSelectedField(HWND,struct StrField far *);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsSetField(HWND,LPSTR,int,struct StrField far *,BOOL);
FRS_CPLUSPLUS BOOL  WINAPI _export FrsSetLicenseKey(LPBYTE);


FRS_CPLUSPLUS LRESULT CALLBACK _export VbxProcessMessage(HWND,UINT,WPARAM,LPARAM,LPINT);
FRS_CPLUSPLUS BOOL         WINAPI _export FrsSetVbxCallback(HWND,VBX_CALLBACK);
FRS_CPLUSPLUS VBX_CALLBACK WINAPI _export FrsGetVbxCallback(HWND);
FRS_CPLUSPLUS HWND WINAPI         _export FrsGetVbxControl(HWND);

/******************************************************************************
               FRS outgoing Messages
*******************************************************************************/

/*******************************************************************************
   FRS_CLOSE:
   This message is sent to your application by the form editor and 
   report executer.

   Form Editor sends this messages before closing the form editor window.
   
   The report executer sends this message before after writing the last
   report line.
*******************************************************************************/
#define FRS_CLOSE    (WM_USER)

/*******************************************************************************
   FRS_SAVE_AS:
   This message is sent to your application by the form editor when a 
   new name is being assigned to the form.
*******************************************************************************/
#define FRS_SAVE_AS   (WM_USER+1)

/******************************************************************************
               FRS internal Messages, starts from WM_USER+789
*******************************************************************************/
#define FRS_NEXT_ITEM  (WM_USER+789)

