{******************************************************************************
               Global Constants
*******************************************************************************}
Const

   FRS_DESIGN_MODE     =$1;
   FRS_HSCROLL         =$2;
   FRS_VSCROLL         =$4;
   FRS_MENU            =$8;
   FRS_TOOLBAR         =$100;
   FRS_USE_PARAMS      =$200;
   FRS_INVISIBLE       =$400;
   FRS_NUM_STYLES      =7;

   CB_USER_SELECTION   =1;
   CB_VERIFY_DATA      =2;
   CB_DRAW_PICTURE     =3;
   CB_ENTER_DATA       =4;

   FFLAG_RETURN_MSG_ID =$1;

   FORM_SIGN       =$DFBA;

   UNITS_PER_INCH  =250;
   NAME_WIDTH      =50;

   SRC_APPL        =0;
   SRC_SYS         =1;
   SRC_CONST       =2;
   SRC_NONE        =3;

   TYPE_NUM        =1;
   TYPE_DBL        =2;
   TYPE_TEXT       =3;
   TYPE_DATE       =4;
   TYPE_PICT       =5;
   TYPE_RADIO      =6;
   TYPE_CHECKBOX   =7;
   TYPE_PUSHBUTTON =8;

   DT_MMDDYY       =0;
   DT_DDMMYY       =1;
   DT_MMDDYYYY     =2;
   DT_MMMDDYYYY    =3;

   FLAG_TRIM       =$1;
   FLAG_SUP_ZERO   =$2;
   FLAG_PAD_ZERO   =$4;
   FLAG_CAPS       =$8;
   FLAG_FIRST_CAP  =$10;
   FLAG_SMALL      =$20;
   FLAG_COMMA      =$40;
   FLAG_WRAP       =$80;
   FLAG_WORD_WRAP  =$100;
   FLAG_CUSTOM_DATA =$200;
   FLAG_FLEX_SIZE  =$400;
   FLAG_SHARED     =$1000;
   FLAG_PROTECT    =$2000;
   FLAG_3D_OUTLINE =$4000;

   {Systems Fields}
   SYS_DATE        =0;
   SYS_TIME        =1;
   SYS_ADD_KEY     =2;
   SYS_VERIFY_KEY  =3;
   SYS_VIEW_DATA   =4;
   SYS_UPDATE_DATA =5;
   SYS_DELETE_DATA =6;
   SYS_FIND_NEXT   =7;
   SYS_FIND_PREV   =8;
   SYS_RESET       =9;
   MAX_SYS_FIELDS  =10;

   PAINT_ITEMS     =2;
   PAINT_WIN       =3;
   PAINT_PARTIAL_WIN  =5;

   {Error codes}
   ERR_NO_FILE     =1;
   ERR_NO_DEVICE   =2;
   ERR_NO_MEM      =3;
   ERR_BAD_EXP     =4;
   ERR_SUSPEND     =5;
   ERR_ZERO_DIVIDE =6;
   ERR_TYPE_MISMATCH =7;
   ERR_INCOMPLETE  =8;
   ERR_DUPLICATE   =9;
   ERR_PRINTER     =10;
   ERR_IO          =11;
   ERR_DISPLAY     =12;
   ERR_WRAP        =13;
   ERR_FONT        =14;
   ERR_OTHER       =15;

   ERR_BAD_WND     =16;
   ERR_NO_FRS_ID   =17;
   ERR_BAD_FRS_ID  =18;
   ERR_NO_OUTFILE  =19;
   ERR_NO_TER      =20;
   ERR_IN_TER      =21;

   {messages send by the dll}
   FRS_CLOSE       =(WM_USER);
   FRS_SAVE_AS     =(WM_USER+1);

type
{*****************************************************************************
                        Field Structure
*****************************************************************************}
   
   StrField = record
         source: Integer;              { source of field data: application,calculation,system, constant etc }

         name: array [0..NAME_WIDTH+1] of char; { field name }
         FieldId: Integer;             { another optional id that may be defined by the calling application} 
         Fieldtype: Integer;           { numeric/alphanumeric/logical/date }
         width: Integer;               { field data width as stored in your database}
         DecPlaces: Integer;           { decimal places for numeric fields }
         AllowChanges: Integer;        { Allow modification of the following fields }

         InUse: Integer;               { TRUE=in use, FALSE=not in use }
         flags: Integer;               { flags }
         SysIdx: Integer;              { index into the system field table for system fields }

         DateFormat: Integer;          { date format }  
         
         DateDelim: array [0..1] of char;  { date delimiter character, i.e. / or - }
         ParaChar: array [0..1] of char; { specify the new paragraph indicator character 
                                           in the first byte.  Needed only for a word/wrapped
                                           text field. }

         CurrencySymbol: array [0..3] of char;  { currency symbol }

         NegSignPrefix: array [0..3] of char;   { negative sign prefix }
         NegSignSuffix: array [0..3] of char;   { negative sign suffix }
         PosSignPrefix: array [0..3] of char;   { positive sign prefix }
         PosSignSuffix: array [0..3] of char;   { positive sign suffix }

         CharData: pChar;              { character data, pointer to an object of size = field.width+1 }
         NumData: LongInt;             { numeric data (long) }
         DblData: double;              { numeric data for field = TYPE_DBL }

         RadioGroup: Integer;          { group number for radio button fields }

         section: Integer;             { section that holds the field (report time only)}
         misc: Integer;                { used for miscellaneous purposes }


         UseCount: Integer;             {use count for the shared fields}
         FldReserved1: array [0..9] of char; { reserved to pad to 128}
       end;


   AStrField = array [0..0] of StrField;  { pointer to the field structure }
   PStrField = ^AStrField;

{*****************************************************************************
   The parameter structure definition that is used by your application
   to specify the operation parameters and text data to the 'form' routine.
   For an example for using this structure, refer to the demo.c file.
*****************************************************************************}

   StrForm = record 
       InDesignMode: LongBool;  {TRUE to invoke the form designer, FALSE to invoke
                                 the form executer}
       x: Integer;       { Initial x position of the editing window,
                           you may specify CW_USEDEFAULT to use default values.}
       y: Integer;       { Initial y position of the editing window.}
       width : Integer;  { Initial width of the window in device units,
                           you may specify CW_USEDEFAULT to use default values.}
       height : Integer; { Initial height of the editing window.  When you
                           use CW_USEDEFAULT for width, the height parameter is 
                           ingnored.}

       UserSelection: Pointer;
                           { Arguments: (hWnd: THandle; fields : StrField) 

                             A pointer to the function returning the user 
                           selected field through the structure pointer.
                           This callback function is called in the designer
                           mode. 
                           Your application returns the chosen field through 
                           the second parameter.
                           The function returns a TRUE value if 
                           successful. 

                           When using ReportEase as a DLL, this pointer must
                           be passed using the MakeProcInstance function.  Your
                           application must define this function as exportatable
                           and include it it the EXPORT section of the 
                           definition file.
                           }

       VerifyData: Pointer; 
                           { Arguments: (hWnd: THandle; fields:  StrField)
                             A pointer to the user routine that validate a 
                           field data. This callback function is called 
                           in the form execution mode.  The newly entered
                           data for the field is returned by the NumData,
                           DblData for CharData member variables.
                           }
                           
       DrawPicture: Pointer; 
                           { Arguments: (hWnd: THandle; hDC: THandle;
                              PictId, FieldId: Integer; var rect: TRect)
                             A pointer to the user routine which is called
                             by the dll in the execution mode to draw a 
                             'user draw' field.
                           }
                           
       EnterData: Pointer; 
                           { Arguments: (hWnd: THandle; fields: StrField;
                              x,y,width,height: Integer)
                              This callback function is called by the dll
                              in the execution mode to prompt data for the
                              'custom data fields'.
                           }

       FileName: array [0..131] of char;  { form file name. If an existing file is specified,
                           the following fields are ignored.} 
                                            
       DataSetName: array [0..19] of char ;{ (Specify for a new file) Your application can 
                           specify a data set name which can be used to
                           associate the application data to the form.  This
                           is an optional field. }

        ShowMenu: LongBool;  { show the menu bar ? }
        ShowHorBar: LongBool;{ show the horizonatal scroll bar }
        ShowVerBar: LongBool;{ show the vertical scroll bar }
        ShowToolBar: LongBool;{ show the the toolbar icons}

        hInst: THandle;    {  Handle of the current instanaces. }
        hPrevInst: THandle;{  Handle of the previous instances. }
        hParentWnd: THandle;{ Handle to the parent window }
        hFrWnd: THandle;   {  Form main window handle, will be filled by RE later  }
        style: LongInt;    {  Editor window style }
        FontTypeFace: array [0..31] of char; { Default type face, example: TmwRmn Courier, etc }
        open: LongBool;    { TRUE indicates an open window (parameter block in use)}
        modified: LongBool;{ TRUE when the file modified, and needs to be saved }
       end;


{*****************************************************************************
                        Form Header Structure
*****************************************************************************}
   StrFormHdr = record
           FormSign: LongInt;          { Form File Signature}

           name: array [0..NAME_WIDTH+1] of char; { report name}

           DataSetName: array [0..19] of char;  { Your application can specify a data set
                                       name which can be used to associate the
                                       application data to the form.  This
                                       is an optional information. }

           TotalItems: Integer;      { screen items in the form template }
           FieldCount: Integer;      { total number of fields }
           FontCount: Integer;       { number of entries in the font table }
           SectionCount: Integer;    { number of form parts}

           LeftMargin: Single;       { margins in inches}
           RightMargin: Single;
           TopMargin: Single;
           BottomMargin: Single;

           PrinterName: array [0..NAME_WIDTH+1] of char;      { name of the printer }
           PrinterDriver: array [0..NAME_WIDTH+1] of char;    { printer driver name }

           flags: Integer;           { RFLAG_ series flags }

           DateFormat: Integer;      { 0=MM/DD/YY, 1=DD/MM/YY }

           RulerType: Integer;        { RULER_OFF,RULER_INCH,RULER_CM}

           SecBannerHeight: Integer;  { height (logical units) of the section banner}
           FileFormatId: Integer;     { records the file format changes}
           HdrReserved1: array [0..141] of char;
       end;

{*****************************************************************************
                        User draw picture information
*****************************************************************************}
   StrPict = record
           hDC: THandle;          {Device context of the report output device}
           PictId,                {picture id value}
           FieldId,               {FieldId of the picture}
           x,                     {picture location}
           y,
           width,                 {picture size}
           height:Integer;
       end;
